Bug 1418941 - RHEL7.3 + osp8: Juniper contrail vrouter provision failed due to error in puppet code
Summary: RHEL7.3 + osp8: Juniper contrail vrouter provision failed due to error in pup...
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: Red Hat OpenStack
Classification: Red Hat
Component: openstack-puppet-modules
Version: 8.0 (Liberty)
Hardware: All
OS: Linux
high
high
Target Milestone: async
: 8.0 (Liberty)
Assignee: Emilien Macchi
QA Contact: Arik Chernetsky
URL:
Whiteboard:
Depends On:
Blocks: 1347518
TreeView+ depends on / blocked
 
Reported: 2017-02-03 08:45 UTC by shaju
Modified: 2019-01-09 18:22 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-01-09 18:22:22 UTC
Target Upstream Version:


Attachments (Terms of Use)

Description shaju 2017-02-03 08:45:44 UTC
Description of problem:
As part of OOO integration with contrail. While we use the RH puppet code (/etc/puppet/modules/contrail/manifests/vrouter/config.pp)to provision contrail vrouter. Provision failed with below error: 

Error: Could not match ${ip_to_steal} at /etc/puppet/modules/contrail/manifests/vrouter/config.pp:81 on node overcloud-compute-0.localdomain 

Version-Release number of selected component (if applicable):

osp8 + redhat-7.3

How reproducible:
Provision contrail-vrouter using osp8 with redhat7.3 image. I have used below command to provision vrouter

openstack overcloud deploy --templates -e /usr/share/openstack-tripleo-heat-templates/environments/network-isolation.yaml -e ${template_base_dir}/network-environment.yaml -e ${template_base_dir}/neutron-opencontrail.yaml --control-flavor control --compute-flavor compute --ceph-storage-flavor ceph-storage \
--control-scale $control_scale --compute-scale $compute_scale --ceph-storage-scale $ceph_scale --ntp-server $ntpserver --neutron-network-type vxlan --neutron-tunnel-types vxlan


Possible bug. The puppet snippet below.
  $ip_to_steal = getvar(regsubst("ipaddress_${compute_device}", '[.-]', '_', 'G'))
  $control_network_dev = {
    'NETWORKS/control_network_ip' => { value => ${ip_to_steal} },   =====> here the ip_to_steal might need double quote
    'VIRTUAL-HOST-INTERFACE/ip'   => { value => "${ip_to_steal}/{$mask}" }

Steps to Reproduce:
1.
2.
3.

Actual results:


Expected results:


Additional info:

Comment 1 Guil Barros 2017-02-14 15:27:23 UTC
Fixed upstream:
https://github.com/Juniper/puppet-contrail/pull/3/files#diff-0a7dcb5375876d72cc4a0bc44f0ad3d7R81

Requesting Juniper submit new build for puppet-contrail.

Comment 2 Red Hat Bugzilla Rules Engine 2017-02-14 15:27:29 UTC
This bugzilla has been removed from the release and needs to be reviewed and Triaged for another Target Release.

Comment 3 Jason Guiditta 2017-03-03 15:24:44 UTC
This bug should be cloned to desired releases, and once juniper has backported the linked fix to appropriate stable/<version> branches in upstream, we can pull those commits into the appropriate OSP version. This one (for OSP 8) is ready upstream (though there are 2 newer commits as well, do we need those? do they need a BZ?):
https://github.com/Juniper/puppet-contrail/commit/440f5db632c00e25cff7cb9f0d4f65656177fc16

Comment 4 Jason Guiditta 2017-03-03 15:34:20 UTC
Actually, it appears the diff listed above pointed to the same issue described in https://bugzilla.redhat.com/show_bug.cgi?id=1394528 - is this bug a duplicate?  Was the original bug not really fixed?

Comment 5 Emilien Macchi 2017-03-03 17:13:54 UTC
Shaju, do we need to clone this bug for newer versions of OSP Director? Can you check Jason's questions?

Thanks!

Comment 6 shaju 2017-03-04 00:27:57 UTC
This is file is coming form openstack puppet not from director. we need a fix in puppet-contrail.noarch  1.0.0-1.c0f7cdegit.el7ost

[root@undercloud ~]# rpm -q --whatprovides /etc/puppet/modules/contrail/manifests/vrouter/config.pp
puppet-contrail-1.0.0-1.c0f7cdegit.el7ost.noarch
[root@undercloud ~]# yum list puppet-contrail
Loaded plugins: search-disabled-repos
Installed Packages
puppet-contrail.noarch                                       1.0.0-1.c0f7cdegit.el7ost                                        @rhel-7-server-openstack-10-rpms

Comment 7 Jason Guiditta 2017-03-06 17:06:27 UTC
For OSP 10, this is correct, for <10, puppet-contrail live in the openstack-puppet-modules rpm.  I don't think anyone is saying this bug belongs in OOO.  In comment #4, I am asking for OSP 8/liberty, is the referenced BZ, which is closed.  That bug refers to the same issue described here (also for OSP 8).  I have checked the code in both OSP and rdo for liberty in puppet-contrail, and the referenced change (https://github.com/Juniper/puppet-contrail/pull/3/files#diff-0a7dcb5375876d72cc4a0bc44f0ad3d7R81) appears to be in both places.  I think This bug for OSP 8 may be a non-issue, and we just need to get OSP 9 (BZ #1394529) and 10 (no BZ that I see, maybe change this one to be for 10?) updated to include these fixes.  FWIW, I am not seeing the changes upstream in the Juniper repo[1][2], which is the first step to making this happen.

[1] https://github.com/Juniper/puppet-contrail/commits/stable/mitaka
[2] https://github.com/Juniper/puppet-contrail/commits/stable/newton

Comment 8 Jason Guiditta 2017-03-13 16:46:16 UTC
Forgot needinfo for comment #7

Comment 9 shaju 2017-03-13 19:06:23 UTC
Hi Shaju,

This fix doesn't apply to stable/newton branch of puppet-contrail.

Regards,
Michael

On 8 Mar 2017, at 00:50, Shaju V.K <shajuvk@juniper.net> wrote:

Hi Michael,
Redhat committed a change on puppet code for osp8, we need to have the same fix on mitaka and newton as per comment#7 on Bugzilla. Could you please check.
https://bugzilla.redhat.com/show_bug.cgi?id=1418941
 
Thanks,
Shaju


Note You need to log in before you can comment on or make changes to this bug.